//-----------------------------------
// Procedures sous-programme Ctrl->CV
//-----------------------------------



//----------------------------------------------------
//----------------------------------------------------
//--------------------  CTRL CV ----------------------
//----------------------------------------------------
//----------------------------------------------------

//-----------------------------------------
// HANDLER CC MIDI
// Ecoute sur les controleurs ctrl1, ctrl2 et ctrl3
// Convertit la valeur des controleurs vers les 3 sorties CV
// Procedure pour convertisseur ctrl -> CV
//----------------------------------------
void MyHandle2CtrlCV(byte channel, byte number, byte value) {
    if (number!=Ctrl1 && number!=Ctrl2 && number!=Ctrl3)
       return;
    vdac=value*32;          // Mapper sur 12bits
    if (Ctrl1==number) {
            writeDAC(DAC1,vdac);    // ecrire dans le DAC 1
            return;
    }
    if (Ctrl2==number) {
            writeDAC(DAC2,vdac);    // ecrire dans le DAC 2
            return;
    }
    if (Ctrl3==number) {
            writeDAC(DAC3,vdac);    // ecrire dans le DAC 3
            return;
    }
}

//----------------------------------------------------
// Sous-programme de conversion de Controleurs vers CV
// 3 controleurs libres vers 3 sorties CV
//----------------------------------------------------
void ConversionMidiCtrlCV(void){
  MIDI.setHandleControlChange(MyHandle2CtrlCV);  // Definit handler CC
  lcd.clear();                     // RAZ LCD
  lcd.print(F("** Ctrl -> CV **"));   // Titre du module active
  aff_menu_MidiCtrlCV();               // affiche les parametres en cours
  while (1) {                      // boucle infinie
    MIDI.read();                  // lecture du buffer midi et traitement
    gestion_menu_MidiCtrlCV();        // test touche de fonctions
    if (readButtons(BNAV)==B_ESC) // test si touche ESC enfoncée
      break;                    // Si oui, on sort de la boucle
  }
  MIDI.disconnectCallbackFromType(midi::ControlChange); // Deconnexion handler CC
}


//--------------------------------------------
// Menu pour le module conversion midi vers CV
//--------------------------------------------
void aff_menu_MidiCtrlCV(void) {
    lcd.setCursor(0,1);
    lcd.print("C");             // affiche valeur controleur CV1
    lcd.print(Ctrl1,DEC);
    lcd.printByte(CAR_SEP);
    lcd.print("C");             // affiche valeur controleur CV2
    lcd.print(Ctrl2,DEC);
    lcd.printByte(CAR_SEP);
    lcd.print("C");             // affiche valeur controleur CV3
    lcd.print(Ctrl3,DEC);
    lcd.printByte(CAR_SEP);
    lcd.print(F("----"));
}

//---------------------------------------------------
// Gestion des touches convertisseur controleur -> CV
//---------------------------------------------------
void gestion_menu_MidiCtrlCV(void) {
    // Lire la valeur du bouton
    valbouton=readButtons(BFUNC);
    if (valbouton==0)     // Si aucun bouton appuye on sort
        return;           // pour ne pas perdre de temps
        
    rafLCD=0;
    switch(valbouton) {
        case B_MAINT:           // Bouton maintenu appuye
            break;
        case B_F1:              // Valeur controleur 1
            if (Ctrl1==MAXCTRL) // Si valeur maxi atteinte
                Ctrl1=MINCTRL;  // Remettre la valeur mini
            else
                Ctrl1++;        // sinon incrementer le numero de controleur
            writeDAC(DAC1,0);   // RAZ du DAC 1    
            rafLCD=1;           // Rafraichir LCD
            break;
        case B_F2:              // Choix mode midi
            if (Ctrl2==MAXCTRL) // Si valeur maxi atteinte
                Ctrl2=MINCTRL;  // Remettre la valeur mini
            else
                Ctrl2++;        // sinon incrementer le numero de controleur
            writeDAC(DAC2,0);   // RAZ du DAC 2   
            rafLCD=1;           // Rafraichir LCD
            break;
        case B_F3:              // Choix mode gestion velocite
            if (Ctrl3==MAXCTRL) // Si valeur maxi atteinte
                Ctrl3=MINCTRL;  // Remettre la valeur mini
            else
                Ctrl3++;        // sinon incrementer le numero de controleur
            writeDAC(DAC3,0);   // RAZ du DAC 3  
            rafLCD=1;           // Rafraichir LCD
            break;
        case B_F4:              // Rien...
            break;
    }
    if (rafLCD==1) {            // Si flag affichage
        aff_menu_MidiCtrlCV();  // Rafraichir menu controleur
        rafLCD=0;
    }
}
