//-----------------------------------------------
// Procedures sous-programme sequenceur euclidien
//-----------------------------------------------



//----------------------------------------------------
// Fonction calcul pattern euclidien
// modification fa : decalage de bit pour arriver a 16
//----------------------------------------------------
unsigned int euclid(int k, int n){ // inputs: k=beats, n=total,  o = offset
  int decalage;
  int pauses = n-k;
  int pulses = k;
  int per_pulse = pauses/k;
  int remainder = pauses%pulses;  
  unsigned int workbeat[n];
  unsigned int outbeat;
  unsigned int working;
  int workbeat_count=n;
  int a; 
  int b; 
  int trim_count;
  decalage=16-n;
  for (a=0;a<n;a++){ // Populate workbeat with unsorted pulses and pauses 
    if (a<pulses){
      workbeat[a] = 1;
    }
    else {
      workbeat [a] = 0;
    }
  }
  if (per_pulse>0 && remainder <2){ // Handle easy cases where there is no or only one remainer  
    for (a=0;a<pulses;a++){
      for (b=workbeat_count-1; b>workbeat_count-per_pulse-1;b--){
        workbeat[a]  = ConcatBin (workbeat[a], workbeat[b]);
      }
      workbeat_count = workbeat_count-per_pulse;
    }

    outbeat = 0; // Concatenate workbeat into outbeat - according to workbeat_count 
    for (a=0;a < workbeat_count;a++){
      outbeat = ConcatBin(outbeat,workbeat[a]);
    }
	outbeat = outbeat << decalage;

    return outbeat;
  }
  else { 
    int groupa = pulses;
    int groupb = pauses; 
    int iteration=0;
    if (groupb<=1){
    }
    while(groupb>1){ //main recursive loop
      if (groupa>groupb){ // more Group A than Group B
        int a_remainder = groupa-groupb; // what will be left of groupa once groupB is interleaved 
        trim_count = 0;
        for (a=0; a<groupa-a_remainder;a++){ //count through the matching sets of A, ignoring remaindered
          workbeat[a]  = ConcatBin (workbeat[a], workbeat[workbeat_count-1-a]);
          trim_count++;
        }
        workbeat_count = workbeat_count-trim_count;

        groupa=groupb;
        groupb=a_remainder;
      }
      else if (groupb>groupa){ // More Group B than Group A
        int b_remainder = groupb-groupa; // what will be left of group once group A is interleaved 
        trim_count=0;
        for (a = workbeat_count-1;a>=groupa+b_remainder;a--){ //count from right back through the Bs
          workbeat[workbeat_count-a-1] = ConcatBin (workbeat[workbeat_count-a-1], workbeat[a]);

          trim_count++;
        }
        workbeat_count = workbeat_count-trim_count;
        groupb=b_remainder;
      }
      else if (groupa == groupb){ // groupa = groupb 
        trim_count=0;
        for (a=0;a<groupa;a++){
          workbeat[a] = ConcatBin (workbeat[a],workbeat[workbeat_count-1-a]);
          trim_count++;
        }
        workbeat_count = workbeat_count-trim_count;
        groupb=0;
      }
      else {
        //        Serial.println("ERROR");
      }
      iteration++;
    }
    outbeat = 0; // Concatenate workbeat into outbeat - according to workbeat_count 
    for (a=0;a < workbeat_count;a++){
      outbeat = ConcatBin(outbeat,workbeat[a]);
    }
	outbeat = outbeat << decalage;
    return outbeat;
  }
}

// Function to find the binary length of a number by counting bitwise 
int findlength(unsigned int bnry){
  boolean lengthfound = false;
  int length=1; // no number can have a length of zero - single 0 has a length of one, but no 1s for the sytem to count
  for (int q=32;q>=0;q--){
    int r=bitRead(bnry,q);
    if(r==1 && lengthfound == false){
      length=q+1;
      lengthfound = true;
    }
  }
  return length;
}

// Function to concatenate two binary numbers bitwise 
unsigned int ConcatBin(unsigned int bina, unsigned int binb){
  int binb_len=findlength(binb);
  unsigned int sum=(bina<<binb_len);
  sum = sum | binb;
  return sum;
}



//-------------------------------------------------
// Affiche les 3 patterns sous forme semi-graphique
//-------------------------------------------------
void aff_graph_euclidean(void) {
byte tempNoChar;
int i;
	for (i=8; i>0; i--) {
		tempNoChar=bitRead(highByte(ceuclid[0]),i-1)+bitRead(highByte(ceuclid[1]),i-1)*2+bitRead(highByte(ceuclid[2]),i-1)*4;
		if (!tempNoChar)
			lcd.print(F(" "));
		else
			lcd.printByte(tempNoChar-1);
	}
	for (i=8; i>0; i--) {
		tempNoChar=bitRead(lowByte(ceuclid[0]),i-1)+bitRead(lowByte(ceuclid[1]),i-1)*2+bitRead(lowByte(ceuclid[2]),i-1)*4;
		if (!tempNoChar)
			lcd.print(F(" "));
		else
			lcd.printByte(tempNoChar-1);
	}
}

//----------------------------------------
// Affiche un pattern euclidien
// du genre X.X..XX.X.XX.
//----------------------------------------
void aff_euclidean(int sequence, byte nbsteps) {
byte i,j;
	j=0;
    for (i=8; i>0; i--,j++) {
		if (j<nbsteps) {
			if (bitRead( highByte(sequence),i-1))
				lcd.print(F("X"));
			else
				lcd.print(F("."));
		}
		else {
			lcd.print(F(" "));
		}
    }
    for (i=8; i>0; i--,j++) {
		if (j<nbsteps) {
			if (bitRead( lowByte(sequence),i-1))
				lcd.print(F("X"));
			else
				lcd.print(F("."));
		}
		else {
			lcd.print(F(" "));
		}
    }
	
	
}

// byte step_euclidean(int sequence, byte nostep) {
// byte i,j;
// byte myoct;
	// if (nostep<8) {
		// return bitRead( highByte(sequence),7-nostep);
	// }
	// else {
		// return bitRead( lowByte(sequence),15-nostep);
	
	// }
// }

//---------------------------------------------	
// HANDLER CONTINUE arpegiateur
// Gestion du message continue pour arpegiateur
//---------------------------------------------	
void MyHandleContinueSeqEuclidean(void) {
  SeqEuclideanStart=1;
}


//------------------------------------------
// HANDLER START arpegiateur	
// Gestion du message start pour arpegiateur
//------------------------------------------	
void MyHandleStartSeqEuclidean(void) {
	SeqEuclideanStart=1;
	ClockMidi=0;
	PosSeqEuclidian[0]=-1;
	PosSeqEuclidian[1]=-1;
	PosSeqEuclidian[2]=-1;
}

//-----------------------------------------
// HANDLER STOP arpegiateur
// Gestion du message stop pour arpegiateur
//-----------------------------------------
void MyHandleStopSeqEuclidean(void) {
	SeqEuclideanStart=0;
	ClockMidi=0;
	PosSeqEuclidian[0]=-1;
	PosSeqEuclidian[1]=-1;
	PosSeqEuclidian[2]=-1;
}

//----------------------------------------------------- 
// HANDLER CLOCK arpegiateur
// Procedure appellee a chaque tick de l'horloge maitre
// 1 tick= 1/24eme de noire
//----------------------------------------------------- 
void  MyHandleClockSeqEuclidean(void) {
	ClockMidi++;
	// lcd.setCursor(0,1);
	// digitsLcd(PosSeqEuclidian[0],2);
	// lcd.print(" ");
	// digitsLcd(PosSeqEuclidian[1],2);
	// lcd.print(" ");
	// digitsLcd(PosSeqEuclidian[2],2);
	
	if (ClockMidi==1) {       // Si debut de division
		if (PosSeqEuclidian[0]==-1)
			PosSeqEuclidian[0]=0;
		if (PosSeqEuclidian[1]==-1)
			PosSeqEuclidian[1]=0;
		if (PosSeqEuclidian[2]==-1)
			PosSeqEuclidian[2]=0;
      PlayNoteSeqEuclidan();      // On joue
	}    
  
  //else
  //  digitalWrite(GATE1,LOW);
      
	if (ClockMidi==24/ListeClockMenu[ClockDivider]) {
		ClockMidi=0;     
		PosSeqEuclidian[0]++;
		PosSeqEuclidian[1]++;
		PosSeqEuclidian[2]++;
      
      //digitalWrite(GATE1,LOW);
      //delay(5);
		if (PosSeqEuclidian[0]>=teuclid[0])
			PosSeqEuclidian[0]=0;
		if (PosSeqEuclidian[1]>=teuclid[1])
			PosSeqEuclidian[1]=0;
		if (PosSeqEuclidian[2]>=teuclid[2])
			PosSeqEuclidian[2]=0;
	}
}

void PlayNoteSeqEuclidan(void)
{              
byte valbit;                        
int i,j;
	// Pour chacun des 3 patterns
	for (i=0;i<3; i++) {
		// Si le steps <8 lire octet de poids fort
		if (PosSeqEuclidian[i]<8) {
			valbit=bitRead(highByte(ceuclid[i]),7-PosSeqEuclidian[i]);
		}
		// Sinon lire octet de poids faible
		else {
			valbit=bitRead(lowByte(ceuclid[i]),15-PosSeqEuclidian[i]);
		}
		// Si le bit est a 1
		// alors ouvrir le gate correspondant
		if (valbit) {
			// Ouvrir le GATE correct en fonction du pattern en cours
			switch(i) {
				case 0:
					digitalWrite(GATE1,HIGH);
					// Test si on est pas deja en noteon
					// On fait note-off avant de redeclencher
					if (GateEucState[0]) {
						MIDI.sendNoteOff(NOTEBASEEUCLID,0,1);
					}
					MIDI.sendNoteOn(NOTEBASEEUCLID,127,1);
					break;
				case 1:
					digitalWrite(GATE2,HIGH);
					// Test si on est pas deja en noteon
					// On fait note-off avant de redeclencher
					if (GateEucState[1]) {
						MIDI.sendNoteOff(NOTEBASEEUCLID,0,2);
					}
					MIDI.sendNoteOn(NOTEBASEEUCLID,127,2);
					break;
				case 2:
					digitalWrite(GATE3,HIGH);
					// Test si on est pas deja en noteon
					// On fait note-off avant de redeclencher
					if (GateEucState[2]) {
						MIDI.sendNoteOff(NOTEBASEEUCLID,0,3);
					}
					MIDI.sendNoteOn(NOTEBASEEUCLID,127,3);
					break;
			}	
			// Resetter heure de depart du gate
			StartGateEuc[i]=millis();
			// Setter l'etat du gate du pattern courant a 1
			GateEucState[i]=1;
		} 
	}

}




//--------------------------------------
// Initialisation du sequencer euclidien
//--------------------------------------
void init_EuclideanSequencer(void) {
	// beuclid[0]=2;
	// teuclid[0]=16;
	ceuclid[0]=euclid(beuclid[0],teuclid[0]);
	// beuclid[1]=4;
	// teuclid[1]=16;
	ceuclid[1]=euclid(beuclid[1],teuclid[1]);
	// beuclid[2]=8;
	// teuclid[2]=16;
	ceuclid[2]=euclid(beuclid[2],teuclid[2]);
	StartGateEuc[0]=millis();	// Init Time du gate 1
	StartGateEuc[1]=millis();	// Init Time du gate 1
	StartGateEuc[2]=millis();	// Init Time du gate 1
	GateEucState[0]=0;	// Etat Gate 1 off
	GateEucState[1]=0;	// Etat Gate 2 off
	GateEucState[2]=0;	// Etat Gate 3 off
	xm_euc=1;
	PosSeqEuclidian[0]=-1;
	PosSeqEuclidian[1]=-1;
	PosSeqEuclidian[2]=-1;
	lcd.setCursor(0,0);
	aff_graph_euclidean();
	lcd.setCursor(0,1);
	lcd.print(F("S01"));
//	lcd.printByte(CAR_LEFT);
	lcd.print(F("<"));
	lcd.print(F("B"));
	digitsLcd(beuclid[0],2);
	lcd.print(F(" S"));
	digitsLcd(teuclid[0],2);
	lcd.print(F("  x"));
	lcd.print(ListeClockMenu[ClockDivider]);
	// Creation des caracteres mour affichage des triggers
	lcd.createChar(0, CARV1);
	lcd.createChar(1, CARV2);
	lcd.createChar(2, CARV3);
	lcd.createChar(3, CARV4);
	lcd.createChar(4, CARV5);
	lcd.createChar(5, CARV6);
	lcd.createChar(6, CARV7);
}

//----------------------------------------
// Gestion menu principal des fonctions du
// sequenceur euclidien
//----------------------------------------
void gestion_menu_euclidean_sequencer(void) {
		valbouton=readButtons(BFUNC);
	   switch(valbouton) {
			case B_MAINT:           // Bouton maintenu appuye
				break;
			case B_F1:              // Choix Pattern
				xm_euc=1;
				rafLCD=1;
				break;
			case B_F2:				// Choix nombre de beats du pattern
				xm_euc=2;
				rafLCD=1;
				break;
			case B_F3:            	// Choix nombre de steps du pattern
				xm_euc=3;
				rafLCD=1;
				break;
			case B_F4:    			// division horloge        
				xm_euc=4;
				rafLCD=1;
				break;
		}
		// Lecture potentiometre pour longueur de gate
		valpot=readPotArp(POT);
		if (lastvalpot!=valpot) {
			lastvalpot=valpot;
		}
		// Fermeture des gates si temps dépassé
		if (millis()-StartGateEuc[0]>+valpot) {
			if (GateEucState[0]) {
				digitalWrite(GATE1,LOW);
				MIDI.sendNoteOff(NOTEBASEEUCLID,0,1);
				StartGateEuc[0]=millis();
				GateEucState[0]=0;
			}
		}
		if (millis()-StartGateEuc[1]>+valpot) {
			if (GateEucState[1]) {
				digitalWrite(GATE2,LOW);
				MIDI.sendNoteOff(NOTEBASEEUCLID,0,2);
				StartGateEuc[1]=millis();
				GateEucState[1]=0;
			}
		}
		if (millis()-StartGateEuc[2]>+valpot) {
			if (GateEucState[2]) {
				digitalWrite(GATE3,LOW);
				MIDI.sendNoteOff(NOTEBASEEUCLID,0,3);
				StartGateEuc[2]=millis();
				GateEucState[2]=0;
			}
		}
		
		
		if (rafLCD) {
			rafLCD=0;
			lcd.setCursor(3,1);
			lcd.print(F(" "));
			lcd.setCursor(7,1);
			lcd.print(F(" "));
			lcd.setCursor(11,1);
			lcd.print(F(" "));
			lcd.setCursor(15,1);
			lcd.print(F(" "));
			lcd.setCursor(xm_euc*4-1,1);
			lcd.print(F("<"));
			if (xm_euc>1) {
			lcd.setCursor((xm_euc-1)*4-1,1);
			lcd.print(F(">"));
			}
		}
}

//-----------------------------------------
// Sequenceur euclidien
// Trois sequence a choisir
// reglage du nombre de steps et de beats dans ces steps
// reglage de la longueur du gate
// reglage de la division d'horloge
//-----------------------------------------
void EuclideanSequencer(void) {
	GateOff();
	lcd.clear();                     // RAZ LCD
	lcd.print(F("* EUCLIDEAN SEQ*"));   // Titre du module active
	xm_euc=1;
	ym_euc=1;
	init_EuclideanSequencer();
	lastvdac=0;
	MIDI.setHandleClock(MyHandleClockSeqEuclidean);        // Definit handler horloge
	MIDI.setHandleStart(MyHandleStartSeqEuclidean);        // Definit handler  start
	MIDI.setHandleStop(MyHandleStopSeqEuclidean);          // Definit handler  stop
	MIDI.setHandleContinue(MyHandleContinueSeqEuclidean);  // Definit handler  Continue
	lastvalpot=0;
	while (1) {                      // boucle infinie
		MIDI.read(); 	
		gestion_menu_euclidean_sequencer();		// gestion affichage sequenceur euclidean
		valbouton=readButtons(BNAV);
		switch(valbouton) {
			case B_ESC:
	//			reset_partie_midi()
				// Recreation des caracteres pour menu
				lcd.createChar(0, symbup);      // Creation fleche UP 
				lcd.createChar(1, symbdown);    // Creation fleche DOWN
				MIDI.disconnectCallbackFromType(midi::Continue); // Deconnexion handler continue
				MIDI.disconnectCallbackFromType(midi::Stop); // Deconnexion handler stop
				MIDI.disconnectCallbackFromType(midi::Start); // Deconnexion handler start
				MIDI.disconnectCallbackFromType(midi::Clock); // Deconnexion handler clock
				return;
				break;
			case B_UP:              // Bouton UP
				switch(xm_euc) {
					case 1:			// selection pattern precedent
						if (ym_euc>1) {
							ym_euc--;
							lcd.setCursor(1,1);
							digitsLcd(ym_euc,2);				
							lcd.setCursor(0,0);
							aff_graph_euclidean();
							lcd.setCursor(5,1);
							digitsLcd(beuclid[ym_euc-1],2);				
							lcd.setCursor(9,1);
							digitsLcd(teuclid[ym_euc-1],2);				
							
						}
						break;
					case 2:			// decrement nombre de beats
						if (beuclid[ym_euc-1]>1) {
							beuclid[ym_euc-1]--;
							ceuclid[ym_euc-1]=euclid(beuclid[ym_euc-1],teuclid[ym_euc-1]);
							lcd.setCursor(0,0);
							aff_graph_euclidean();
							lcd.setCursor(5,1);
							digitsLcd(beuclid[ym_euc-1],2);
						}
						break;	
					case 3:			// decrement nombre de steps
						if (teuclid[ym_euc-1]>1) {
							teuclid[ym_euc-1]--;
							lcd.setCursor(9,1);
							digitsLcd(teuclid[ym_euc-1],2);
							// Si nombre de steps <nombre de beats, decrementer les beats
							if (teuclid[ym_euc-1]<beuclid[ym_euc-1]) {
								beuclid[ym_euc-1]=teuclid[ym_euc-1];
								lcd.setCursor(5,1);
								digitsLcd(beuclid[ym_euc-1],2);
							}
							ceuclid[ym_euc-1]=euclid(beuclid[ym_euc-1],teuclid[ym_euc-1]);
							lcd.setCursor(0,0);
							aff_graph_euclidean();
						}
						break;	
					case 4:			// decrement diviseur horloge
						if (ClockDivider>0) {
							ClockDivider--;        
							lcd.setCursor(14,1);
							lcd.print(ListeClockMenu[ClockDivider]);							
							digitalWrite(GATE1,LOW); 
							digitalWrite(GATE2,LOW); 
							digitalWrite(GATE3,LOW); 
							MIDI.sendNoteOff(NOTEBASEEUCLID,0,1);
							MIDI.sendNoteOff(NOTEBASEEUCLID,0,2);
							MIDI.sendNoteOff(NOTEBASEEUCLID,0,3);							
							ClockMidi=0;  						
						}
						break;	
				}
				break;
			case B_DOWN:            // Bouton DOWN
				switch(xm_euc) {
					case 1:			// selection pattern suivant
						if (ym_euc<3) {
							ym_euc++;
							lcd.setCursor(1,1);
							digitsLcd(ym_euc,2);
							lcd.setCursor(0,0);
							aff_graph_euclidean();
							lcd.setCursor(5,1);
							digitsLcd(beuclid[ym_euc-1],2);				
							lcd.setCursor(9,1);
							digitsLcd(teuclid[ym_euc-1],2);				
						}
						break;
					case 2:			// increment nombre de beats
						if (beuclid[ym_euc-1]<16 && beuclid[ym_euc-1]<teuclid[ym_euc-1]) {
							beuclid[ym_euc-1]++;
							ceuclid[ym_euc-1]=euclid(beuclid[ym_euc-1],teuclid[ym_euc-1]);
							lcd.setCursor(0,0);
							aff_graph_euclidean();
							lcd.setCursor(5,1);
							digitsLcd(beuclid[ym_euc-1],2);
						}
						break;				
					case 3:			// increment nombre de steps
						if (teuclid[ym_euc-1]<16) {
							teuclid[ym_euc-1]++;
							ceuclid[ym_euc-1]=euclid(beuclid[ym_euc-1],teuclid[ym_euc-1]);
							lcd.setCursor(0,0);
							aff_graph_euclidean();
							lcd.setCursor(9,1);
							digitsLcd(teuclid[ym_euc-1],2);
						}
						break;	
					case 4:			// increment diviseur horloge
						if (ClockDivider<ITEMS_CLOCK) {
							ClockDivider++;        
							lcd.setCursor(14,1);
							lcd.print(ListeClockMenu[ClockDivider]);							
							digitalWrite(GATE1,LOW); 
							digitalWrite(GATE2,LOW); 
							digitalWrite(GATE3,LOW); 
							ClockMidi=0;  						
						}
						break;	
				}
				// decrementer parametre en court
				// le rafraichir
				break;
		}	
	}
}              

