//-------------------------------------
// Procedures sous-programme note->gate
//-------------------------------------



//----------------------------------------------------
//----------------------------------------------------
//-----------------  NOTE GATE -----------------------
//----------------------------------------------------
//----------------------------------------------------

//-------------------------------- 
// Handler Note Off MIDI
// POur gestion 3 notes -> 3 gates
// RAZ des CV correspondants
//-------------------------------- 
void  MyHandleNoteOffGATE(byte channel, byte pitch, byte velocity) {
     if (pitch==Note1) {
        digitalWrite(GATE1,LOW);    // Gate 1 off
        writeDAC(DAC1,0);           // RAZ CV1
        
     }
     if (pitch==Note2) {
        digitalWrite(GATE2,LOW);    // Gate 2 off
        writeDAC(DAC2,0);           // RAZ CV2
     }
     if (pitch==Note3) {
        digitalWrite(GATE3,LOW);    // Gate 3 off
        writeDAC(DAC3,0);           // RAZ CV3
     }
        
}

//------------------------------------------------------------- 
// Handler Note On vers GATE
// 3 notes observees 
// Vers les 3 GATES
// Les CV correspondants sont regles en fonction de la velocité
//------------------------------------------------------------- 
void MyHandleNoteOnGATE(byte channel, byte pitch, byte velocity) {
int cv2;
  // Si velocity == 0 alors on a recu un note off
  //---------------------------------------------
  if (velocity==0) {
     MyHandleNoteOffGATE(channel,pitch,velocity);
     return;
  }
  vdac=32*velocity;
  if (pitch==Note1) {
     digitalWrite(GATE1,HIGH);    // Ouverture GATE 1
     writeDAC(DAC1,vdac);         // CV1 en fonction de la velocite
     return;
  }
  if (pitch==Note2) {
     digitalWrite(GATE2,HIGH);    // Ouverture GATE 2
     writeDAC(DAC2,vdac);         // CV2 en fonction de la velocite
     return;
  }
  if (pitch==Note3) {
     digitalWrite(GATE3,HIGH);    // Ouverture GATE 3
     writeDAC(DAC3,vdac);         // CV3 en fonction de la velocite
  }
}



// ---------------------------------------------------
// Sous-programme de conversion de 3 notes vers 3 GATE
// Note appuyée GATE ON
// Note relachée GATE OFF
// ---------------------------------------------------
void ConversionMidiNoteGate(void) {
  GateOff();
  MIDI.setHandleNoteOn(MyHandleNoteOnGATE);       // Definit handler note on 
  MIDI.setHandleNoteOff(MyHandleNoteOffGATE);     // Definit handler note off
  lcd.clear();                     // RAZ LCD
  lcd.print(F("** NOTE>GATE  **"));   // Titre du module active
  aff_menu_MidiNoteGATE();               // affiche les parametres en cours
  while (1) {                      // boucle infinie
    MIDI.read();                  // lecture du buffer midi et traitement
    gestion_menu_MidiNoteGATE();        // test touche de fonctions
    if (readButtons(BNAV)==B_ESC) // test si touche ESC enfoncée
      break;                    // Si oui, on sort de la boucle
  }
  MIDI.disconnectCallbackFromType(midi::NoteOff); // Deconnexion handler note off
  MIDI.disconnectCallbackFromType(midi::NoteOn);  // Deconnexion handler note on
}

//--------------------------------------------
// Menu pour le module conversion midi vers CV
//--------------------------------------------
void aff_menu_MidiNoteGATE(void) {
    lcd.setCursor(0,1);
    affNoteLCD(Note1);        // affiche valeur note 2
    lcd.printByte(CAR_SEP);
    affNoteLCD(Note2);        // affiche valeur note 2
    lcd.printByte(CAR_SEP);
    affNoteLCD(Note3);        // affiche valeur note 2
    lcd.printByte(CAR_SEP);
    lcd.print(F("----"));
}

//---------------------------------------------------
// Gestion des touches convertisseur controleur -> CV
//---------------------------------------------------
void gestion_menu_MidiNoteGATE(void) {
    // Lire la valeur du bouton
    valbouton=readButtons(BFUNC);
    if (valbouton==0)     // Si aucun bouton appuye on sort
        return;           // pour ne pas perdre de temps
        
    rafLCD=0;
    switch(valbouton) {
        case B_MAINT:
            break;
        case B_F1:              // Valeur note 1
            if (Note1==MAXNOTE) // Si valeur maxi atteinte
                Note1=MINNOTE;  // Remettre la valeur mini
            else
                Note1++;        // sinon incrementer le numero de note
            digitalWrite(GATE1,LOW);   
            rafLCD=1;           // Rafraichir LCD
            break;
        case B_F2:              // Choix mode midi
            if (Note2==MAXNOTE) // Si valeur maxi atteinte
                Note2=MINNOTE;  // Remettre la valeur mini
            else
                Note2++;        // sinon incrementer le numero de note
            digitalWrite(GATE2,LOW);  // RAZ du gate 2   
            rafLCD=1;           // Rafraichir LCD
            break;
        case B_F3:              // Choix mode gestion velocite
            if (Note3==MAXNOTE) // Si valeur maxi atteinte
                Note3=MINNOTE;  // Remettre la valeur mini
            else
                Note3++;        // sinon incrementer le numero de note
            digitalWrite(GATE3,LOW);  // RAZ du gate 3   
            rafLCD=1;           // Rafraichir LCD
            break;
        case B_F4:              // Rien...
            break;
    }
    if (rafLCD==1) {            // Si flag affichage
        aff_menu_MidiNoteGATE();  // Rafraichir menu note
        rafLCD=0;
    }
}
