//------------------------------------
// Procedures sous-programme quantizer
//------------------------------------



//----------------------------------------------------
//----------------------------------------------------
//-------------------  QUANTIZER ---------------------
//----------------------------------------------------
//----------------------------------------------------

//---------------------------------------------------------
// Calcul du quantizing
// Renvoie une valeur de note juste
// en arrondissant au plus près la valeur mesurée en entrée
//---------------------------------------------------------
void Quantizer_Calc(void)
{
int c,v;
  vdac=0;                     // Calcul DAC       
  v=analogRead(CVIN);         // Lecture de CV IN
  switch(QModeCV) {           // En fonction du mode CV...
      case VOCT:
         switch(QNote) {
            case SEMITONES:
                v = map(v, 30, 950, 0,60 );    // 61 notes maxi (0 a 60) en Volt/Octave
                c = constrain(v, 0, 60);
                vdac = pgm_read_word_near( VOct + c);
                break;
            case BLANCHES:
                v = map(v, 30, 950, 0,35 );    // 36 notes maxi (0 a 35) en Volt/Octave
                c = constrain(v, 0, 35);
                vdac = pgm_read_word_near( VOct_blanches + c);
                break;
         }
         break;
 
      case HVOLT:
         switch(QNote) {
            case SEMITONES:
                  v = map(v, 0, 1023, 0, 51);    //  52 notes maxi (0 a 51) en Hetz/Volt
                  c = constrain(v, 0, 51);
                  vdac = pgm_read_word_near( HVolt + c);
                  break;
            case BLANCHES:
                  v = map(v, 0, 1023, 0, 29);    //  30 notes blanches maxi (0 a 29) en Hetz/Volt
                  c = constrain(v, 0, 29);
                  vdac = pgm_read_word_near( HVolt_blanches + c);
                break;
         }




        break;
      case SX150:
        break;
  }
  if (lastvdac!=vdac) {
     lastvdac=vdac;
     writeDAC(DAC1,vdac);
     lcd.setCursor(0,0);
     //if (c<10)
     //    lcd.print(" ");
     //lcd.print(c,DEC);
     if (QNote==SEMITONES)
        affNoteLCD(c+36);
      else
        affNoteBLCD(c);
      
  }
}
//---------------------------------
// Gestion des touches du quantizer
//---------------------------------
void gestion_menu_Quantizer(void) {
    // Lire la valeur du bouton
    valbouton=readButtons(BFUNC);
    if (valbouton==0)     // Si aucun bouton appuye on sort
        return;           // pour ne pas perdre de temps
        
    rafLCD=0;
    switch(valbouton) {
        case B_MAINT:           // Bouton maintenu appuye
            break;
        case B_F1:              // Choix Mode CV
            if (QModeCV<3)
                QModeCV++;
            else
                QModeCV=1;
            rafLCD=1;    
            break;
        case B_F2:            // Choix type de note
            if (QNote==SEMITONES)
               QNote=BLANCHES;
            else
               QNote=SEMITONES;
            rafLCD=1;    
            break;
        case B_F3:            
            rafLCD=1;    
            break;
        case B_F4:            
            rafLCD=1;    
            break;
    }
    if (rafLCD==1) {
        aff_menu_Quantizer();
        rafLCD=0;
    }
}


//-------------------------------
// Affichage du menu du quantizer
//-------------------------------
void aff_menu_Quantizer(void) {
    lcd.setCursor(0,1);
     switch(QModeCV) {
        case VOCT:
            lcd.print(F("Oct"));
          break;
        case HVOLT:
            lcd.print(F("Hz."));
          break;
        case SX150:
            lcd.print(F("SX1"));
          break;
    }
    lcd.printByte(CAR_SEP);
    switch(QNote) {
        case SEMITONES:
          lcd.print(F("Sem"));
          break;
        case BLANCHES:
          lcd.print(F("Not"));
          break;
    }
    lcd.printByte(CAR_SEP);
}    



//---------------------------------------------
// mesure la tension sur l'entrée CV IN
// quantize cette tension et la reporte sur CV1
// mode volt/octave, Hertz/volt, SX, etc
//---------------------------------------------
void Quantizer(void) {
  GateOff();
  lcd.clear();                     // RAZ LCD
  lcd.print(F("     *QUANTIZER*"));   // Titre du module active
  aff_menu_Quantizer();               // affiche les parametres en cours
  lastvdac=0;
  while (1) {                      // boucle infinie
    Quantizer_Calc();
    gestion_menu_Quantizer();        // test touche de fonctions
    if (readButtons(BNAV)==B_ESC) // test si touche ESC enfoncée
      break;                    // Si oui, on sort de la boucle
  }
}
