//-----------------------------------------
// procedures pour gerer les affichages LCD
// programme principal midicv.ino
//-----------------------------------------


//--------------------------------------------------------
// Affiche une donne numerique avec des 0 non significatif
// nbdigits = longueur totale du nombre  entre 1 et 3 chiffres
//--------------------------------------------------------
void digitsLcd(byte valeur, byte nbdigits) {
  if (nbdigits==3 && valeur <100)
      lcd.print(F("0"));
  if (valeur<10)
      lcd.print(F("0"));
  lcd.print(valeur,DEC);
}

//--------------------------------------------------------
// Affiche "On" si valeur >0 sinon Off
// le tout a la position x,y
//--------------------------------------------------------
void OnOffLcd(byte valeur, byte x, byte y) {
  lcd.setCursor(x,y);      
  if (valeur)
      lcd.print(F("On "));
  else
      lcd.print(F("Off"));
}


//----------------------------------------
// Affiche un octet en binaire
// Sert pour du debug
// A enlever une fois le programme termine
//----------------------------------------
void aff_binary(byte oct) {
byte i;
    lcd.print(F("B"));
    for (i=8; i>0; i--) {
        if (bitRead(oct,i-1))
            lcd.print(F("1"));
        else
            lcd.print(F("0"));
    }
}

//----------------------------------------
// Affiche une note sous forme americaine
// Exemple C#3
// Le parametre est le numero de note midi
//----------------------------------------
void affNoteLCD(byte pitch) {
   if (pitch>=24) {
    //lcd.print(Note[ (pitch % 12 ) ]);
    strcpy_P(BuffAff, (char*)pgm_read_word(&(Note[(pitch % 12 )])));
    lcd.print(BuffAff); 
    lcd.print((pitch/12)-2,DEC);
//    if (strlen(Note[ (pitch % 12 ) ])<2)
    if (strlen(BuffAff)<2)
       lcd.print(" ");
  }
  else {
    lcd.print(F("---"));
  }
}

//----------------------------------------
// Affiche une note sous forme americaine
// Exemple C3
// N'affiche que les notes blanches
// Pas les demi-tons
// Le parametre est un index.
//----------------------------------------
void affNoteBLCD(byte pitch) {
  
    //lcd.print(Note[ (pitch % 12 ) ]);
    strcpy_P(BuffAff, (char*)pgm_read_word(&(NoteB[(pitch % 7 )])));
    lcd.print(BuffAff); 
    lcd.print((pitch/7)+1,DEC);
    lcd.print(" ");
}

