const uint16_t VOct[] PROGMEM = {
// Definition des valeurs DAC
// pour conversion midi vers CV
// Standard Volt/Octave
// (61 VALEURS)
0,68,137,205,273,341,410,478,546,614,683,751,
819,887,956,1024,1092,1160,1229,1297,1365,1433,1502,1570,
1638,1706,1775,1843,1911,1979,2048,2116,2184,2252,2321,2389,
2457,2525,2594,2662,2730,2798,2867,2935,3003,3071,3140,3208,
3276,3344,3413,3481,3549,3617,3686,3754,3822,3890,3959,4027,
4095,
};

const uint16_t VOct_blanches[] PROGMEM = {
// Definition des valeurs DAC
// pour conversion midi vers CV
// Standard Volt/Octave
// Juste les notes blanches
// (36 VALEURS)
0, 137, 273,341, 478, 614, 751,
819, 956, 1092,1160, 1297, 1433, 1570,
1638, 1775, 1911,1979, 2116, 2252, 2389,
2457, 2594, 2730,2798, 2935, 3071, 3208,
3276, 3413, 3549,3617, 3754, 3890, 4027,
4095,
};



const uint16_t HVolt[] PROGMEM = {
// Definition des valeurs DAC
// pour conversion midi vers CV
// Standard Hertz/Volt
// (52 VALEURS)
205,217,230,244,258,273,290,307,325,344,365,387,
410,434,460,487,516,547,579,614,650,689,730,773,
819,868,919,974,1032,1093,1158,1227,1300,1377,1459,1546,
1638,1736,1839,1948,2064,2187,2317,2454,2600,2755,2919,3092,
3276,3471,3677,3896,
};
const uint16_t HVolt_blanches[] PROGMEM = {
// Definition des valeurs DAC
// pour conversion midi vers CV
// Standard Hertz/Volt
// Juste les notes blanches
// (30 VALEURS)
205, 230, 258,273, 307, 344, 387,
410, 460, 516,547, 614, 689, 773,
819, 919, 1032,1093, 1227, 1377, 1546,
1638, 1839, 2064,2187, 2454, 2755, 3092,
3276, 3677,
};




// Menu principal
const char menu_prin_0[] PROGMEM = "--EEPROM SAVE-- ";
const char menu_prin_1[] PROGMEM = "1)MIDI > CV/GATE";
const char menu_prin_2[] PROGMEM = "2)MIDI CTRL->CV ";
const char menu_prin_3[] PROGMEM = "3)MIDI NOTE>GATE";
const char menu_prin_4[] PROGMEM = "4)Arpegiateur   ";
const char menu_prin_5[] PROGMEM = "5)Quantizer     ";
const char menu_prin_6[] PROGMEM = "6)Random Wave   ";
const char menu_prin_7[] PROGMEM = "7)Euclidean Seq ";
const char menu_prin_8[] PROGMEM = "8)Rhythm machine";
// Tableau de pointeur qui pointe vers les items
const char *const MenuPrincipal[] PROGMEM =
{   
  menu_prin_0,
  menu_prin_1,
  menu_prin_2,
  menu_prin_3,
  menu_prin_4,
  menu_prin_5,
  menu_prin_6,
  menu_prin_7,
  menu_prin_8
};
#define ITEMS_MENU_PRINCIPAL  9

// Nom des notes
const char Note_1[] PROGMEM = "C";
const char Note_2[] PROGMEM = "C#";
const char Note_3[] PROGMEM = "D";
const char Note_4[] PROGMEM = "D#";
const char Note_5[] PROGMEM = "E";
const char Note_6[] PROGMEM = "F";
const char Note_7[] PROGMEM = "F#";
const char Note_8[] PROGMEM = "G";
const char Note_9[] PROGMEM = "G#";
const char Note_10[] PROGMEM = "A";
const char Note_11[] PROGMEM = "A#";
const char Note_12[] PROGMEM = "B";
const char *const Note[] PROGMEM =
{
  Note_1,
  Note_2,
  Note_3,
  Note_4,
  Note_5,
  Note_6,
  Note_7,
  Note_8,
  Note_9,
  Note_10,
  Note_11,
  Note_12
};

// Nom des notes blanches uniquement
const char NoteB_1[] PROGMEM = "C";
const char NoteB_2[] PROGMEM = "D";
const char NoteB_3[] PROGMEM = "E";
const char NoteB_4[] PROGMEM = "F";
const char NoteB_5[] PROGMEM = "G";
const char NoteB_6[] PROGMEM = "A";
const char NoteB_7[] PROGMEM = "B";
const char *const NoteB[] PROGMEM =
{
  NoteB_1,
  NoteB_2,
  NoteB_3,
  NoteB_4,
  NoteB_5,
  NoteB_6,
  NoteB_7
};



// Motifs de l'arpegiateur
const char Motif_0[] PROGMEM = "Up ";     // UP
const char Motif_1[] PROGMEM = "Dow";   // DOWN
const char Motif_2[] PROGMEM = "U/D";    // UP puis DOWN
const char Motif_3[] PROGMEM = "D/U";    // UP puis DOWN
const char Motif_4[] PROGMEM = "Oup";    // Chaque note sur les octaves sens UP
const char Motif_5[] PROGMEM = "Odw";    // Chaque note sur les octaves sens DOWN
const char Motif_6[] PROGMEM = "Pen";    // Pendulaire
const char Motif_7[] PROGMEM = "Rnd";    // Random
const char Motif_8[] PROGMEM = "132";    // 1..3..2..1..3..2


const char *const MotifsArp[] PROGMEM =
{
  Motif_0,
  Motif_1,
  Motif_2,
  Motif_3,
  Motif_4,
  Motif_5,
  Motif_6,
  Motif_7,
  Motif_8
};
#define ITEMS_MOTIFS_ARP  9       // Nombre de motifs au total

// Liste des numeros de motifs pour associer un nom
#define MOTIF_UP          0
#define MOTIF_DOWN        1
#define MOTIF_UPDOWN      2
#define MOTIF_DOWNUP      3
#define MOTIF_OCTAVEUP    4
#define MOTIF_OCTAVEDOWN  5
#define MOTIF_PENDULE     6
#define MOTIF_RANDOM      7
#define MOTIF_132         8




